#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <errno.h>
#include <process.h>

int main(void)
{
    char *cp;
    char answ;
    char comp;
    char *mcu;
    char *ispmcu;
    char *burn;
    char *burnflags = "";
    FILE *fp;
    char pathname[255];

    for(;;) {
        fputs("\nSelect a compiler:\n\n"
              "  1) GNU AVR-GCC\n"
              "  2) ImageCraft ICCAVR\n\n"
              "Selection -> "
              , stdout);
        comp = _getch();
        fprintf(stdout, "%c\n", comp);
        if(comp == '1' || comp == '2') 
            break;
    }

    if(comp == '1') {
	/*
	 * Copy GCC Makefiles.
	 */
        _searchenv("avr-gcc.exe", "PATH", pathname);
        if(pathname[0]) {
            fputs("\nCopying Makedefs.gcc to Makedefs", stdout);
            system("copy Makedefs.gcc Makedefs");
            fputs("Copying Makerules.gcc to Makerules", stdout);
            system("copy Makerules.gcc Makerules");
            fputs("Copying app\\Makedefs.gcc to app\\Makedefs", stdout);
            system("copy app\\Makedefs.gcc app\\Makedefs");
            fputs("Copying app\\Makerules.gcc to app\\Makerules", stdout);
            system("copy app\\Makerules.gcc app\\Makerules");
        }
    }
    else {
	/*
	 * Copy ICC Makefiles.
	 */
        _searchenv("iccavr.exe", "PATH", pathname);
        if(pathname[0]) {
            fputs("\nCopying Makedefs.icc to Makedefs", stdout);
            system("copy Makedefs.icc Makedefs");
            fputs("Copying Makerules.icc to Makerules", stdout);
            system("copy Makerules.icc Makerules");
            fputs("Copying app\\Makedefs.icc to app\\Makedefs", stdout);
            system("copy app\\Makedefs.icc app\\Makedefs");
            fputs("Copying app\\Makerules.icc to app\\Makerules", stdout);
            system("copy app\\Makerules.icc app\\Makerules");
        }
    }

    /*
     * No compiler found.
     */
    if(pathname[0] == 0) {
        fputs("\n\nCan't find the selected compiler. :-(\n\n"
              "This could mean either of the following:\n"
              "  1: You don't have the compiler installed.\n"
              "  2: You don't have your PATH environment variable set right.\n"
              "Here is your PATH variable:\n\n"
              , stderr);
        system("PATH");
        return 3;
    }

    for(;;) {
        fputs("\nSelect a target device:\n\n"
              "  1) ATmega128, red Ethernut board\n"
              "  2) ATmega103, green Ethernut board\n\n"
              "Selection -> "
              , stdout);
        answ = _getch();
        fprintf(stdout, "%c\n", answ);
        if(answ == '1') {
            mcu = (comp == '1') ? "atmega128" : "enhanced";
	    ispmcu = "ATmega128";
            break;
        }
        else if(answ == '2') {
            mcu = (comp == '1') ? "atmega103" : "mega";
	    ispmcu = "ATmega103";
            break;
        }
    }

    /*
     * Select programmer.
     */
    for(;;) {
        fputs("\nWhich isp programmer are you using?\n\n"
              "  1) Parallel port STK200, STK300 or compatible\n"
	      "  2) Serial port STK500 or compatible\n\n"
              "Selection -> "
              , stdout);
        answ = _getch();
        fprintf(stdout, "%c\n", answ);
        if(answ == '1') {
	    burn = "uisp";
	    burnflags = "-dprog=stk200 --erase --upload --verify if=$(TARG)";
            break;
        }
        else if(answ == '2') {
	    burn = "stk500";
	    sprintf(burnflags, "-d%s -e -pf -vf -if$(TARG)", ispmcu);
            break;
        }
    }

    /*
     * Copy libraries for ICC.
     */
    if(comp == '2') {
        char cmd[255];

        if((cp = strrchr(pathname, '\\')) != NULL)
            *cp = 0;
        fprintf(stdout, "\nCopying init files to %s\\..\\lib:\n", pathname);
        sprintf(cmd, "copy lib\\icc\\%s\\*.o %s\\..\\lib", mcu, pathname);
        system(cmd);

        fprintf(stdout, "\nCopying libraries to %s\\..\\lib:\n", pathname);
        sprintf(cmd, "copy lib\\icc\\%s\\*.a %s\\..\\lib", mcu, pathname);
        system(cmd);
    }

    /*
     * Create user configuration.
     */
    if((fp = fopen("UserConf.mk", "w")) == NULL) {
        fprintf(stderr, "Writing UserConf.mk failed: %s\n", strerror(errno));
        return 3;
    }
    fprintf(fp, "MCU=%s\n", mcu);
    fprintf(fp, "BURN=%s\n", burn);
    fprintf(fp, "BURNFLAGS=%s\n", burnflags);
    fprintf(fp, "CRUROM=$(top_srcdir)\\tools\\win32\\crurom.exe\n");
    if(comp == '2') {
	/*
	 * ICC include path.
	 */
        cp = pathname;

        while(*cp) {
            if(*cp == '\\') 
                *cp = '/';
            cp++;
        }
        fprintf(fp, "AVR=%s/..\n", pathname);
    }
    fclose(fp);

    fprintf(stdout, "\nYour system is now configured to build Nut/OS for AVR %s.\n", mcu);
    return 0;
}
